package rene.gui;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JCheckBox;

class CheckboxActionTranslator implements ItemListener
{
	DoActionListener C;
	String S;
	public JCheckBox CB;

	public CheckboxActionTranslator (JCheckBox cb, DoActionListener c, String s)
	{
		C = c;
		S = s;
		CB = cb;
	}

	public void itemStateChanged (ItemEvent e)
	{
		C.itemAction(S, CB.isSelected());
	}
}


/**
 * A Checkbox with modifyable font.
 * <p>
 * To be used in DoActionListener interfaces.
 */

public class CheckboxAction extends JCheckBox
{
	public CheckboxAction (DoActionListener c, String s)
	{
		super(s);
		if (Global.NormalFont != null) setFont(Global.NormalFont);
		addItemListener(new CheckboxActionTranslator(this, c, s));
	}

	public CheckboxAction (DoActionListener c, String s, String h)
	{
		super(s);
		if (Global.NormalFont != null) setFont(Global.NormalFont);
		addItemListener(new CheckboxActionTranslator(this, c, h));
	}

	public void setState (boolean flag)
	{
		setSelected(flag);
	}

	public boolean getState ()
	{
		return isSelected();
	}
}
