package rene.zirkel.help;

import java.awt.BorderLayout;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.InputStreamReader;

import javax.swing.JButton;

import rene.gui.CloseFrame;
import rene.gui.Global;
import rene.gui.MyPanel;
import rene.viewer.Viewer;
import rene.zirkel.Zirkel;

public class Help extends CloseFrame implements ActionListener
{
	Viewer V;
	JButton Close;
	static public String CodePage = "";

	// display the help from subject.txt
	public Help (String subject)
	{
		super(Zirkel.name("help.title", "Help"));
		V = new Viewer();
		if (Global.Background != null) V.setBackground(Global.Background);
		if (Global.NormalFont != null) V.setFont(Global.NormalFont);
		V.setTabWidth(4);
		String lang = Global.name("language", "");
		while (true)
		{
			try
			{
				BufferedReader in;
				try
				{
					if (CodePage.equals(""))
						in = new BufferedReader(new InputStreamReader(
							getClass().getResourceAsStream(
								"/rene/zirkel/docs/" + lang + subject),
							CodePage));
					else in = new BufferedReader(new InputStreamReader(
						getClass().getResourceAsStream(
							"/rene/zirkel/docs/" + lang + subject), CodePage));
				}
				catch (Exception e)
				{
					in = new BufferedReader(new InputStreamReader(getClass()
						.getResourceAsStream(
							"/rene/zirkel/docs/" + lang + subject)));
				}
				while (true)
				{
					String s = in.readLine();
					if (s == null) break;
					V.appendLine(s);
				}
				in.close();
			}
			catch (Exception e)
			{
				if ( !lang.equals(""))
				{
					lang = "";
					continue;
				}
				else
				{
					V.setText(Zirkel.name("help.error",
						"Could not find the help file!"));
				}
			}
			break;
		}
		V.doUpdate(false);

		setLayout(new BorderLayout());
		setSize(600, 600);
		setLocation(120, 70);
		add("Center", V);
		Panel p = new MyPanel();
		p.add(Close = new JButton(Zirkel.name("close", "Close")));
		Close.addActionListener(this);
		add("South", p);
		setPosition("help");
		seticon("rene/zirkel/icon.png");
		setVisible(true);
	}

	@Override
	public void actionPerformed (ActionEvent e)
	{
		if (e.getSource() == Close)
		{
			notePosition("help");
			setVisible(false);
			dispose();
		}
	}
}
